package;

import flash.ui.Mouse;
import org.flixel.FlxButton;
import org.flixel.FlxG;
import org.flixel.FlxGroup;
import org.flixel.FlxPoint;
import org.flixel.FlxSprite;
import org.flixel.FlxState;
import org.flixel.FlxText;
import org.flixel.FlxBasic;
import org.flixel.FlxTilemap;
import org.flixel.FlxObject;
import nme.Assets;

import com.eclecticdesignstudio.motion.Actuate;
import com.eclecticdesignstudio.motion.easing.Elastic;




class Level7 extends BaseLevel
{
	private var door1:Door;
	private var button1:Button;
	private var pU1:FlxSprite;
	
	
	
	override public function create():Void
	{
	

		backGround = new FlxSprite(0,0);
		backGround.alpha = .5;
		backGround.loadGraphic(FlxAssets.bgImage2,false,false,800,600);
		add(backGround);


		map = new FlxTilemap();
		map.loadMap(Assets.getText("assets/mapCSV_Group1_Level7.csv"),FlxAssets.tileImg2,20,20,FlxTilemap.OFF);
		add(map);
		super.create();

		//reput the taco
		taco.y=60;
		taco.x=388;

		//place the player
		ourPlayer.x=396;
		ourPlayer.y=440;
		ourPlayer.facing = FlxObject.LEFT;

		//left small
		 for (i in 0...2) {
			var testSparks4:Sparks = new Sparks(243+(i*15),288,4,1,1);
			enviroGroup.add(testSparks4);
		}	

		//right small
		for (i in 0...2) {
			var testSparks4:Sparks = new Sparks(523+(i*15),288,4,1,1);
			enviroGroup.add(testSparks4);
		}	


		//3 left Bottom
		 for (i in 0...3) {
			var testSparks4:Sparks = new Sparks(265+(i*15),408,2,1,1);
			enviroGroup.add(testSparks4);
		}

		//3 right Bottom
		 for (i in 0...3) {
			var testSparks4:Sparks = new Sparks(485+(i*15),408,2,1,1);

			enviroGroup.add(testSparks4);
		}

		//top
		 for (i in 0...2) {
			var testSparks4:Sparks = new Sparks(361+(i*7),188,4,1,1);
			enviroGroup.add(testSparks4);
		}

		for (i in 0...2) {
			var testSparks4:Sparks = new Sparks(412+(i*7),188,4,1,1);
			testSparks4.facing = FlxObject.LEFT;
			enviroGroup.add(testSparks4);
		}
	
		var lTopH:Door = new Door(135,110,2);
		lTopH.makeHorz();
		doorGroup.add(lTopH);

		var RTopH:Door = new Door(655,110,2);
		RTopH.makeHorz();
		doorGroup.add(RTopH);

		var lTopdoor1:Door = new Door(165,60,2);
		//hdoor1.makeHorz();
		//hdoor1.offset.y=10;
		doorGroup.add(lTopdoor1);

		var lMidDoor:Door = new Door(105,380);
		doorGroup.add(lMidDoor);

		var lBottomDoor:Door = new Door(85,500);
		doorGroup.add(lBottomDoor);

		var rBottomDoor:Door = new Door(705,500);
		doorGroup.add(rBottomDoor);

		var rMidDoor:Door = new Door(685,380);
		doorGroup.add(rMidDoor);

		var rTopDoor:Door = new Door(625,60,2);
		doorGroup.add(rTopDoor);


		var testEnemy1:Enemy1 = new Enemy1(140,355);
		enemyGroup.add(testEnemy1);

		var testEnemy2:Enemy1 = new Enemy1(140,455);
		enemyGroup.add(testEnemy2);

		var testEnemy3:Enemy1 = new Enemy1(640,355);
		enemyGroup.add(testEnemy3);

		var testEnemy4:Enemy1 = new Enemy1(640,455);
		enemyGroup.add(testEnemy4);


		var testEnemy5:Enemy1 = new Enemy1(40,100);
		enemyGroup.add(testEnemy5);

		var testEnemy6:Enemy1 = new Enemy1(640,100);
		enemyGroup.add(testEnemy6);

		var flyingEnemy:Enemy2 = new Enemy2(FlxG.randomRange(300,220),140,this);
		enemyGroup.add(flyingEnemy);

		var blueButton:Button = new Button(395,575,this);
		buttonGroup.add(blueButton);

		var redButton:Button = new Button(395,195,this,2);
		buttonGroup.add(redButton);

		stars.x = taco.x;
		stars.y = taco.y-6;

		//Power Up Section
		add(powerUpGroup);
		//type of powerup, x location, chance of birth, time frame to birth
		powerUpTimer = haxe.Timer.delay(callback(createPowerUp,1,FlxG.randomRange2(600,200),3), FlxG.randomRange2(5000,1000));



		
	}


	override public function nextLevel():Void{
		FlxG.switchState(new Level8());
	}

	override private function resetLevel():Void{
		powerUpTimer.stop();
 		 if (FlxAssets.gameMode==2) {
 		 	if (FlxAssets.hotLives==1) {
 		 		hotGameOver();
 		 	}
 		 	else{
 		 		FlxAssets.hotLives--;
 		 	 	FlxG.switchState(new Level7(2));
 		 	}
 		 }
 		 
 		 if (FlxAssets.gameMode==1) {
 		 	if (FlxAssets.tacoNum>1) {
 				FlxAssets.tacoNum--;
 		 	}
 		 	 FlxG.switchState(new Level7(2));
 		}
 	}
	


	

	
	override public function update():Void
	{
		super.update();
		FlxG.collide(doorGroup,robotGroup);
		FlxG.collide(buttonGroup,robotGroup,buttonHit);
		FlxG.collide(enemyGroup,map);
		FlxG.collide(enemyGroup,doorGroup);
		FlxG.overlap(ourPlayer,enviroGroup,enviroHit);
		FlxG.overlap(robotGroup,enviroGroup,enviroHit);

		FlxG.collide(lazerGroup,powerUGroup,explodePowerU);
		FlxG.collide(lazerGroup,enemyGroup,enemyHit);
		FlxG.collide(lazerGroup,map,mapZap);
		FlxG.collide(lazerGroup,doorGroup,basicZap);


		updateParts();

	}//end of update

	

	

}